﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;

namespace Skywave.Web
{
    public static class ResponseHelper
    {
        public static void RunScript(string script, string scriptName)
        {
            Page page = (Page)HttpContext.Current.Handler;
            page.ClientScript.RegisterStartupScript(typeof(Page), scriptName, script, true);
        }

        public static void Redirect(string url, string target, string windowFeatures, string additionalJavaScript)
        {
            HttpContext context = HttpContext.Current;
            if ((String.IsNullOrEmpty(target) || target.Equals("_self", StringComparison.OrdinalIgnoreCase)) && String.IsNullOrEmpty(windowFeatures))
            {
                context.Response.Redirect(url);
            }
            else
            {
                Page page = (Page)context.Handler;
                if (page == null)
                {
                    throw new InvalidOperationException("Cannot redirect to new window outside Page context.");
                }
                url = page.ResolveClientUrl(url);
                string script;
                if (!String.IsNullOrEmpty(windowFeatures))
                {
                    script = target + @"=window.open(""{0}"", ""{1}"", ""{2}"");";
                }
                else
                {
                    script = target + @"=window.open(""{0}"", ""{1}"");";
                }
                script += additionalJavaScript;
                script = String.Format(script, url, target, windowFeatures);
                page.ClientScript.RegisterStartupScript(typeof(Page), "Redirect", script, true);
                //ScriptManager.RegisterStartupScript(page, typeof(Page), "Redirect", script, true); 
            }
        }
    }
}
